unit VoiceTextAutoVarU;

//Uses the VTxtAuto Automation object, with late bound access through a Variant

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, ToolWin, StdCtrls;

type
  TfrmVTxtAutoLateBound = class(TForm)
    lstProgress: TListBox;
    Label1: TLabel;
    ImageList1: TImageList;
    memText: TMemo;
    ToolBar1: TToolBar;
    btnPlay: TToolButton;
    btnPause: TToolButton;
    btnStop: TToolButton;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnPlayClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    VTxt: Variant;
    BeenPaused: Boolean;
  public
    procedure Log(const Msg: String); overload;
    procedure Log(const Msg: String; const Args: array of const); overload;
  end;

var
  frmVTxtAutoLateBound: TfrmVTxtAutoLateBound;

implementation

{$R *.dfm}

uses
  ComObj;

{ TfrmSAPITest }

procedure TfrmVTxtAutoLateBound.Log(const Msg: String);
begin
  if not Assigned(lstProgress) then
    Exit;
  lstProgress.Items.Add(Msg);
  lstProgress.ItemIndex := lstProgress.Items.Count - 1
end;

procedure TfrmVTxtAutoLateBound.Log(const Msg: String; const Args: array of const);
begin
  Log(Format(Msg, Args))
end;

procedure TfrmVTxtAutoLateBound.FormCreate(Sender: TObject);
begin
  SendMessage(lstProgress.Handle, LB_SETHORIZONTALEXTENT, Width, 0);
  VTxt := CreateOleObject('Speech.VoiceText');
  VTxt.Register('', Application.ExeName);
  //The callback object specified by the ProgID
  //below implements the notification interface
  VTxt.Callback := 'VoiceTextAutoVar.VoiceCallback';
end;

procedure TfrmVTxtAutoLateBound.btnPlayClick(Sender: TObject);
begin
  if not BeenPaused then
    VTxt.Speak(memText.Text, 0)
  else
  begin
    VTxt.AudioResume;
    BeenPaused := False
  end
end;

procedure TfrmVTxtAutoLateBound.btnPauseClick(Sender: TObject);
begin
  if VTxt.IsSpeaking then
  begin
    VTxt.AudioPause;
    BeenPaused := True
  end
end;

procedure TfrmVTxtAutoLateBound.btnStopClick(Sender: TObject);
begin
  VTxt.StopSpeaking;
end;

end.
